let Genode = env:DHALL_GENODE

let Init = Genode.Init

let Child = Init.Child

in  λ(binary : Text) →
      Child.flat
        Child.Attributes::{
        , binary
        , resources = Genode.Init.Resources::{
          , caps = 256
          , ram = Genode.units.MiB 32
          }
        , config = Init.Config::{
          , policies =
            [ Init.Config.Policy::{
              , service = "ROM"
              , label =
                  Init.LabelSelector.Type.Partial
                    { prefix = Some "nixos -> ", suffix = None Text }
              , attributes = toMap { directory = "/eris" }
              }
            ]
          }
        }
