let Genode = env:DHALL_GENODE

let Init = Genode.Init

let Child = Init.Child

in  λ(partitionType : Text) →
    λ(resources : Init.Resources.Type) →
    λ(vfsConfig : Genode.Prelude.XML.Type) →
    λ(binary : Text) →
      Child.flat
        Child.Attributes::{
        , binary
        , resources
        , config = Init.Config::{
          , content = [ vfsConfig ]
          , policies =
            [ Init.Config.Policy::{
              , service = "File_system"
              , label = Init.LabelSelector.prefix "eris_rom"
              , attributes = toMap { root = "/" }
              }
            ]
          }
        , routes =
          [ { service = Init.Service::{ name = "Block" }
            , route = Init.Route.child "drivers" (Some partitionType)
            }
          ]
        }
